import { EntityManager } from './EntityManager';
import { IDatabaseDriver } from './drivers';
import { Configuration, Options } from './utils';
import { EntityMetadata } from './decorators';
export declare class MikroORM {
    em: EntityManager;
    readonly config: Configuration;
    private metadata;
    private readonly driver;
    private readonly logger;
    static init(options: Options): Promise<MikroORM>;
    constructor(options: Options | Configuration);
    connect(): Promise<IDatabaseDriver>;
    isConnected(): Promise<boolean>;
    close(force?: boolean): Promise<void>;
    getMetadata(): Record<string, EntityMetadata>;
}
