"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const metadata_1 = require("../metadata");
const utils_1 = require("../utils");
const entity_1 = require("../entity");
function ManyToOne(options = {}) {
    return function (target, propertyName) {
        const meta = metadata_1.MetadataStorage.getMetadata(target.constructor.name);
        utils_1.Utils.lookupPathFromDecorator(meta);
        const property = { name: propertyName, reference: entity_1.ReferenceType.MANY_TO_ONE, cascade: [entity_1.Cascade.PERSIST, entity_1.Cascade.MERGE] };
        const prop = Object.assign(property, options);
        prop.nullable = !prop.cascade.includes(entity_1.Cascade.REMOVE) && !prop.cascade.includes(entity_1.Cascade.ALL);
        utils_1.Utils.renameKey(prop, 'fk', 'inversedBy');
        meta.properties[propertyName] = prop;
    };
}
exports.ManyToOne = ManyToOne;
