import { EntityProperty, IEntityType, IPrimaryKey } from '../decorators';
import { Collection } from './Collection';
export declare class ArrayCollection<T extends IEntityType<T>> {
    readonly owner: IEntityType<any>;
    [k: number]: T;
    protected readonly items: T[];
    private _property;
    constructor(owner: IEntityType<any>, items?: T[]);
    getItems(): T[];
    toArray(): Record<string, any>[];
    getIdentifiers(field?: string): IPrimaryKey[];
    add(...items: T[]): void;
    set(items: T[]): void;
    remove(...items: T[]): void;
    removeAll(): void;
    contains(item: T): boolean;
    count(): number;
    readonly length: number;
    [Symbol.iterator](): IterableIterator<T>;
    protected propagate(item: T, method: 'add' | 'remove'): void;
    protected propagateToInverseSide(item: T, method: 'add' | 'remove'): void;
    protected propagateToOwningSide(item: T, method: 'add' | 'remove'): void;
    protected shouldPropagateToCollection(collection: Collection<T>, method: 'add' | 'remove'): boolean;
    protected readonly property: EntityProperty<any>;
}
