import { EntityManager } from '../EntityManager';
import { EntityMetadata, IEntity, IEntityType } from '../decorators';
import { LockMode } from '../unit-of-work';
export declare class EntityHelper {
    static init(entity: IEntity, populated?: boolean, lockMode?: LockMode): Promise<IEntity>;
    static decorate<T extends IEntityType<T>>(meta: EntityMetadata<T>, em: EntityManager): void;
    /**
     * defines magic id property getter/setter if PK property is `_id` and there is no `id` property defined
     */
    private static defineIdProperty;
    private static defineBaseProperties;
    private static definePrimaryKeyProperties;
}
