import { EntityData, EntityMetadata, EntityProperty, IEntityType, IPrimaryKey } from '../decorators';
import { FilterQuery } from '../drivers';
export declare class EntityValidator {
    private strict;
    constructor(strict: boolean);
    validate<T>(entity: IEntityType<T>, payload: any, meta: EntityMetadata): void;
    validateProperty<T extends IEntityType<T>>(prop: EntityProperty, givenValue: any, entity: T): any;
    validateParams(params: any, type?: string, field?: string): void;
    validatePrimaryKey<T extends IEntityType<T>>(entity: EntityData<T>, meta: EntityMetadata): void;
    validateEmptyWhere<T extends IEntityType<T>>(where: FilterQuery<T> | IPrimaryKey): void;
    private validateCollection;
    private fixTypes;
    private fixDateType;
    private fixNumberType;
    private fixBooleanType;
}
