"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class Hydrator {
    constructor(factory, driver) {
        this.factory = factory;
        this.driver = driver;
    }
    hydrate(entity, meta, data) {
        if (data[meta.primaryKey]) {
            entity.__primaryKey = data[meta.primaryKey];
        }
        // then process user defined properties (ignore not defined keys in `data`)
        Object.values(meta.properties).forEach(prop => {
            const value = data[prop.name];
            this.hydrateProperty(entity, prop, value);
        });
    }
}
exports.Hydrator = Hydrator;
