import { EntityClass, EntityClassGroup, EntityMetadata, IEntityType } from '../decorators';
import { Configuration } from '../utils';
export declare abstract class MetadataProvider {
    protected readonly config: Configuration;
    constructor(config: Configuration);
    abstract loadEntityMetadata(meta: EntityMetadata, name: string): Promise<void>;
    loadFromCache(meta: EntityMetadata, cache: EntityMetadata): void;
    prepare<T extends IEntityType<T>>(entity: EntityClass<T> | EntityClassGroup<T>): EntityClass<T>;
}
