"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../utils");
const MetadataStorage_1 = require("./MetadataStorage");
class MetadataProvider {
    constructor(config) {
        this.config = config;
    }
    loadFromCache(meta, cache) {
        utils_1.Utils.merge(meta, cache);
    }
    prepare(entity) {
        // save path to entity from schema
        if ('entity' in entity && 'schema' in entity) {
            const schema = entity.schema;
            const meta = MetadataStorage_1.MetadataStorage.getMetadata(entity.entity.name);
            meta.path = schema.path;
            return entity.entity;
        }
        return entity;
    }
}
exports.MetadataProvider = MetadataProvider;
