import { ObjectID } from 'mongodb';
import { Platform } from './Platform';
import { NamingStrategy } from '../naming-strategy';
import { IPrimaryKey } from '../decorators';
import { SchemaHelper } from '../schema';
export declare class MongoPlatform extends Platform {
    protected schemaHelper: SchemaHelper;
    usesPivotTable(): boolean;
    supportsTransactions(): boolean;
    getNamingStrategy(): {
        new (): NamingStrategy;
    };
    normalizePrimaryKey<T = number | string>(data: IPrimaryKey | ObjectID): T;
    denormalizePrimaryKey(data: number | string): IPrimaryKey;
    getSerializedPrimaryKeyField(field: string): string;
    getSchemaHelper(): SchemaHelper;
}
