"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const mongodb_1 = require("mongodb");
const Platform_1 = require("./Platform");
const naming_strategy_1 = require("../naming-strategy");
class MongoPlatform extends Platform_1.Platform {
    usesPivotTable() {
        return false;
    }
    supportsTransactions() {
        return false;
    }
    getNamingStrategy() {
        return naming_strategy_1.MongoNamingStrategy;
    }
    normalizePrimaryKey(data) {
        if (data instanceof mongodb_1.ObjectID) {
            return data.toHexString();
        }
        return data;
    }
    denormalizePrimaryKey(data) {
        return new mongodb_1.ObjectID(data);
    }
    getSerializedPrimaryKeyField(field) {
        return 'id';
    }
    getSchemaHelper() {
        throw new Error(`${MongoPlatform.name} does not provide SchemaHelper`);
    }
}
exports.MongoPlatform = MongoPlatform;
