"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const naming_strategy_1 = require("../naming-strategy");
const Platform_1 = require("./Platform");
const PostgreSqlSchemaHelper_1 = require("../schema/PostgreSqlSchemaHelper");
class PostgreSqlPlatform extends Platform_1.Platform {
    constructor() {
        super(...arguments);
        this.schemaHelper = new PostgreSqlSchemaHelper_1.PostgreSqlSchemaHelper();
    }
    supportsSavePoints() {
        return true;
    }
    getNamingStrategy() {
        return naming_strategy_1.UnderscoreNamingStrategy;
    }
    getParameterPlaceholder(index) {
        return '$' + index;
    }
    usesReturningStatement() {
        return true;
    }
    usesCascadeStatement() {
        return true;
    }
    getReadLockSQL() {
        return 'FOR SHARE';
    }
}
exports.PostgreSqlPlatform = PostgreSqlPlatform;
