import { EntityMetadata, EntityProperty } from '../decorators';
import { QueryOrderMap, QueryType } from './enums';
import { Platform } from '../platforms';
import { JoinOptions } from './QueryBuilder';
import { LockMode } from '../unit-of-work';
export declare class QueryBuilderHelper {
    private readonly entityName;
    private readonly alias;
    private readonly aliasMap;
    private readonly metadata;
    private readonly platform;
    static readonly GROUP_OPERATORS: {
        $and: string;
        $or: string;
    };
    static readonly OPERATORS: {
        $eq: string;
        $in: string;
        $nin: string;
        $gt: string;
        $gte: string;
        $lt: string;
        $lte: string;
        $ne: string;
    };
    private readonly quoteChar;
    constructor(entityName: string, alias: string, aliasMap: Record<string, string>, metadata: Record<string, EntityMetadata>, platform: Platform);
    getWhereParams(conditions: Record<string, any>): any[];
    wrap(field: string): string;
    mapper(type: QueryType, field: string, value?: any, alias?: string): string;
    processData(data: any): any;
    joinOneToReference(prop: EntityProperty, ownerAlias: string, alias: string, type: 'left' | 'inner'): JoinOptions;
    joinManyToOneReference(prop: EntityProperty, ownerAlias: string, alias: string, type: 'left' | 'inner'): JoinOptions;
    joinManyToManyReference(prop: EntityProperty, ownerAlias: string, alias: string, pivotAlias: string, type: 'left' | 'inner'): Record<string, JoinOptions>;
    joinPivotTable(field: string, prop: EntityProperty, ownerAlias: string, alias: string, type: 'left' | 'inner'): JoinOptions;
    processJoins(joins: Record<string, JoinOptions>): string;
    mapJoinColumns(type: QueryType, join: JoinOptions): string[];
    isOneToOneInverse(field: string): boolean;
    getTableName(entityName: string, wrap?: boolean): string;
    getRegExpParam(re: RegExp): string;
    getQueryCondition(type: QueryType, cond: any): string[];
    getQueryOrder(type: QueryType, orderBy: QueryOrderMap, populate: Record<string, string>): string[];
    getClause(type: string, clause: string, data: any): string;
    finalize(type: QueryType, sql: string, meta?: EntityMetadata): string;
    splitField(field: string): [string, string];
    replaceEmptyInConditions(cond: any, field: string): void;
    getLockSQL(lockMode?: LockMode): string;
    updateVersionProperty(set: string[]): void;
    private processComplexParam;
    private prefixAndWrap;
    private getGroupWhereParams;
    private processValue;
    private processObjectValue;
    private getGroupQueryCondition;
    private isPrefixed;
    private fieldName;
}
