"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const SchemaHelper_1 = require("./SchemaHelper");
class MySqlSchemaHelper extends SchemaHelper_1.SchemaHelper {
    getIdentifierQuoteCharacter() {
        return '`';
    }
    getSchemaBeginning() {
        return 'SET NAMES utf8;\nSET FOREIGN_KEY_CHECKS=0;\n\n\n';
    }
    getSchemaEnd() {
        return 'SET FOREIGN_KEY_CHECKS=1;\n';
    }
    getSchemaTableEnd() {
        return ' ENGINE=InnoDB DEFAULT CHARSET=utf8';
    }
    getTypeDefinition(prop) {
        return super.getTypeDefinition(prop, MySqlSchemaHelper.TYPES, MySqlSchemaHelper.DEFAULT_TYPE_LENGTHS);
    }
    getUnsignedSuffix(prop) {
        return ' unsigned';
    }
}
MySqlSchemaHelper.TYPES = {
    number: 'int(?)',
    float: 'float',
    double: 'double',
    string: 'varchar(?)',
    date: 'datetime(?)',
    boolean: 'tinyint(1)',
    text: 'text',
    json: 'json',
};
MySqlSchemaHelper.DEFAULT_TYPE_LENGTHS = {
    number: 11,
    string: 255,
    date: 0,
};
exports.MySqlSchemaHelper = MySqlSchemaHelper;
