import { SchemaHelper } from './SchemaHelper';
import { EntityMetadata, EntityProperty } from '../decorators';
export declare class PostgreSqlSchemaHelper extends SchemaHelper {
    static readonly TYPES: {
        number: string;
        float: string;
        double: string;
        string: string;
        date: string;
        boolean: string;
        text: string;
        json: string;
    };
    static readonly DEFAULT_TYPE_LENGTHS: {
        string: number;
        date: number;
    };
    getSchemaBeginning(): string;
    getSchemaEnd(): string;
    getAutoIncrementStatement(meta: EntityMetadata): string;
    getTypeDefinition(prop: EntityProperty): string;
    getUnsignedSuffix(prop: EntityProperty): string;
    supportsSequences(): boolean;
    indexForeignKeys(): boolean;
    dropTable(meta: EntityMetadata): string;
}
