import { EntityMetadata, EntityProperty } from '../decorators';
export declare abstract class SchemaHelper {
    getIdentifierQuoteCharacter(): string;
    getSchemaBeginning(): string;
    getSchemaEnd(): string;
    getSchemaTableEnd(): string;
    getAutoIncrementStatement(meta: EntityMetadata): string;
    getPrimaryKeySubtype(meta: EntityMetadata): string;
    getTypeDefinition(prop: EntityProperty, types?: Record<string, string>, lengths?: Record<string, number>): string;
    getUnsignedSuffix(prop: EntityProperty): string;
    supportsSchemaConstraints(): boolean;
    supportsSchemaMultiAlter(): boolean;
    supportsSequences(): boolean;
    quoteIdentifier(field: string): string;
    dropTable(meta: EntityMetadata): string;
    indexForeignKeys(): boolean;
    createPrimaryKeyColumn(meta: EntityMetadata, prop: EntityProperty): string;
    createColumn(meta: EntityMetadata, prop: EntityProperty, nullable: boolean): string;
}
