"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const SchemaHelper_1 = require("./SchemaHelper");
class SqliteSchemaHelper extends SchemaHelper_1.SchemaHelper {
    getAutoIncrementStatement(meta) {
        return 'AUTOINCREMENT';
    }
    getSchemaBeginning() {
        return 'PRAGMA foreign_keys=OFF;\n\n\n';
    }
    getSchemaEnd() {
        return 'PRAGMA foreign_keys=ON;\n';
    }
    getPrimaryKeySubtype(meta) {
        return 'PRIMARY KEY';
    }
    getTypeDefinition(prop) {
        const t = prop.type.toLowerCase();
        return SqliteSchemaHelper.TYPES[t] || SqliteSchemaHelper.TYPES.string;
    }
    supportsSchemaConstraints() {
        return false;
    }
    supportsSchemaMultiAlter() {
        return false;
    }
}
SqliteSchemaHelper.TYPES = {
    number: 'INTEGER',
    boolean: 'INTEGER',
    date: 'TEXT',
    string: 'TEXT',
};
exports.SqliteSchemaHelper = SqliteSchemaHelper;
