import { EntityData, IEntity, IEntityType } from '../decorators';
import { ChangeSet } from './ChangeSet';
import { EntityIdentifier, EntityValidator } from '../entity';
export declare class ChangeSetComputer {
    private readonly validator;
    private readonly originalEntityData;
    private readonly identifierMap;
    private readonly metadata;
    constructor(validator: EntityValidator, originalEntityData: Record<string, EntityData<IEntity>>, identifierMap: Record<string, EntityIdentifier>);
    computeChangeSet<T extends IEntityType<T>>(entity: T): ChangeSet<T> | null;
    private computePayload;
    private processReference;
    private processManyToOne;
    private processManyToMany;
    private processOneToOne;
}
