import { EntityData, EntityMetadata, EntityProperty, IEntity, IEntityType, IPrimaryKey } from '../decorators';
import { Collection, ReferenceType } from '../entity';
export declare class Utils {
    static isDefined(data: any): data is object;
    static isObject<T = Record<string, any>>(o: any): o is T;
    static isString(s: any): s is string;
    static isNumber<T = number>(s: any): s is T;
    static equals(a: any, b: any): boolean;
    static unique<T = string>(items: T[]): T[];
    static flatten<T>(arrays: T[][]): T[];
    static merge(target: any, ...sources: any[]): any;
    static diff(a: Record<string, any>, b: Record<string, any>): Record<keyof (typeof a & typeof b), any>;
    static diffEntities<T extends IEntityType<T>>(a: T, b: T): EntityData<T>;
    static prepareEntity<T extends IEntityType<T>>(e: T): EntityData<T>;
    static copy(entity: any): any;
    static asArray<T>(data?: T | T[]): T[];
    static renameKey(payload: any, from: string, to: string): void;
    static getParamNames(func: Function | string): string[];
    static isPrimaryKey(key: any): key is IPrimaryKey;
    static extractPK(data: any, meta?: EntityMetadata): IPrimaryKey | null;
    static isEntity<T = IEntity>(data: any): data is T;
    static isObjectID(key: any): boolean;
    static isEmpty(data: any): boolean;
    static className(classOrName: string | Function): string;
    /**
     * uses some dark magic to get source path to caller where decorator is used
     */
    static lookupPathFromDecorator(meta: EntityMetadata, stack?: string[]): string;
    static getObjectType(value: any): string;
    static runSerial<T = any, U = any>(items: Iterable<U>, cb: (item: U) => Promise<T>): Promise<T[]>;
    static isCollection(item: any, prop?: EntityProperty, type?: ReferenceType): item is Collection<IEntity>;
    static normalizePath(...parts: string[]): string;
}
