import { EntityMetadata, EntityProperty, IEntity } from '../decorators';
export declare class ValidationError extends Error {
    private readonly entity?;
    constructor(message: string, entity?: IEntity<string | number> | undefined);
    getEntity(): IEntity | undefined;
    static fromWrongPropertyType(entity: IEntity, property: string, expectedType: string, givenType: string, givenValue: string): ValidationError;
    static fromCollectionNotInitialized(entity: IEntity, prop: EntityProperty): ValidationError;
    static fromMissingPrimaryKey(meta: EntityMetadata): ValidationError;
    static fromWrongReference(meta: EntityMetadata, prop: EntityProperty, key: keyof EntityProperty, owner?: EntityProperty): ValidationError;
    static fromWrongTypeDefinition(meta: EntityMetadata, prop: EntityProperty): ValidationError;
    static fromWrongOwnership(meta: EntityMetadata, prop: EntityProperty, key: keyof EntityProperty): ValidationError;
    static fromMissingOwnership(meta: EntityMetadata, prop: EntityProperty): ValidationError;
    static fromMergeWithoutPK(meta: EntityMetadata): void;
    static fromUnknownBaseEntity(meta: EntityMetadata): ValidationError;
    static transactionRequired(): ValidationError;
    static entityNotManaged(entity: IEntity): ValidationError;
    static notVersioned(meta: EntityMetadata): ValidationError;
    static multipleVersionFields(meta: EntityMetadata, fields: string[]): ValidationError;
    static invalidVersionFieldType(meta: EntityMetadata): ValidationError;
    static lockFailed(entityOrName: IEntity | string): ValidationError;
    static lockFailedVersionMismatch(entity: IEntity, expectedLockVersion: number | Date, actualLockVersion: number | Date): ValidationError;
    private static fromMessage;
}
